# Supported algorithms

The library aims to support a few core algorithms that will be well suited for production use and other algorithms that are interesting to compare against.

*  [Uniformly sampled](algorithm_uniformly_sampled.md)
*  Linear key reduction (TODO)
*  Curve key reduction (TODO)
*  Wavelets (TODO)

# How to integrate the library

*  [Handling asserts](handling_asserts.md)
*  [Implementing an allocator](implementing_an_allocator.md)
*  Creating a skeleton
*  Creating a clip
*  Compressing a clip
*  Decompressing a clip

# Performance metrics

*  [Carnegie-Mellon University database performance](cmu_performance.md)
*  [Paragon database performance](paragon_performance.md)
*  [Matinee fight scene performance](fight_scene_performance.md)

# Research

*  [Arithmetic accuracy](research_arithmetic_accuracy.md)

# Miscellaneous

*  [The ACL file format](the_acl_file_format.md)
*  [Rotation and vector formats](rotation_and_vector_formats.md)
*  [Error metrics](error_metrics.md)
